import model.AdminUser
import model.DefaultUser
import model.ManagerUser
import model.User
import java.security.SecureRandom
import java.security.spec.KeySpec
import java.time.LocalDate
import javax.crypto.SecretKey
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec
import java.util.Base64

val authorizeList = mutableListOf<User>()
val salt = "sallllt"
private const val HASH_LENGTH = 256
private const val ITERATIONS = 65536

fun main(){
    authorizeList.add(AdminUser(email = "@1", password = hashPassword("qwerty123", salt), login = "aboba", lastAuthorizeDate = LocalDate.of(2022, 11, 25), userId = 1))
    authorizeList.add(ManagerUser(email = "@2", password = hashPassword("qwerty123", salt), login = "abiba", lastAuthorizeDate = LocalDate.of(2023, 3, 10), userId = 2))
    authorizeList.add(DefaultUser(email = "@3", password = hashPassword("qwerty123", salt), login = "abobus", lastAuthorizeDate = LocalDate.of(2023, 5, 15), userId = 3))

    while (true){
        println("1) registration")
        println("2) authorization")
        var choosen = readln()
        if (choosen == "1"){
            authorizeList.add(registration())
            authorizeList.forEach{
                println(it.userId)
                println(it.email)
                println(it.password)
                println(it.login)
            }
        }
        else{
            println(authorization())
        }
    }
}

fun registration(): User{
    println("email")
    val userEmail = readlnOrNull()
    checkNotNull(userEmail)
    require(userEmail.contains("@")){
        "add @ to email"
    }

    println("password")
    val userPassword = readlnOrNull()
    checkNotNull(userPassword)
    require(userPassword.length >= 8){
        "more longer password"
    }

    println("password again")
    val userPasswordTwo = readlnOrNull()
    checkNotNull(userPasswordTwo)
    require(userPassword == userPasswordTwo){
        "nea"
    }

    println("login")
    val userLogin = readlnOrNull()
    checkNotNull(userLogin)
    require(userLogin.length >= 4){
        "more longer login"
    }

    println("1)admin, 2)manager, 3)defaultUser")
    val role = readlnOrNull()
    checkNotNull(role)

    return when(role){
        "1" -> return AdminUser(
            authorizeList.size + 1,
            login = userLogin,
            password = hashPassword(userPassword, salt),
            lastAuthorizeDate = LocalDate.now(),
            email = userEmail,
        )
        "2" -> return ManagerUser(
            authorizeList.size + 1,
            login = userLogin,
            password = hashPassword(userPassword, salt),
            lastAuthorizeDate = LocalDate.now(),
            email = userEmail,
        )
        "3" -> return DefaultUser(
            authorizeList.size + 1,
            login = userLogin,
            password = hashPassword(userPassword, salt),
            lastAuthorizeDate = LocalDate.now(),
            email = userEmail,
        )

        else -> {throw IllegalArgumentException("error")}
    }
}

fun authorization(): String{
    var adminChoose = true
    println("email")
    val userEmail = readlnOrNull()
    checkNotNull(userEmail)
    val user = authorizeList.find { it.email == userEmail }
    require(user != null){
        "no user with that email"
    }

    println("password")
    val userPassword = readlnOrNull()
    checkNotNull(userPassword)
    require(user.password == hashPassword(userPassword, salt)){
        "incorrect password"
    }

    if (user is AdminUser){
        while (adminChoose == true){
            adminChoose = adminFunc(user)
        }
    }

    return "agada"
}

fun adminFunc(user: AdminUser): Boolean{
    println("1) вывести всех пользователей")
    println("2) поменять пароль пользователя")
    println("3) удалить пользователя")
    println("4) вывести с сортировкой по убыванию")
    println("5) назад")

    var choosen = readln()
    when(choosen){
        "1" -> user.allUsers(authorizeList)
        "2" -> user.changeUserPassword(authorizeList)
        "3" -> user.removeUser(authorizeList)
        "4" -> user.allUsersSorted(authorizeList)
        "5" -> return false
    }
    return true
}

fun hashPassword(password: String, salt: String): String {
    val saltBytes = Base64.getDecoder().decode(salt)
    val spec = PBEKeySpec(password.toCharArray(), saltBytes, ITERATIONS, HASH_LENGTH)
    val factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256")
    val hash = factory.generateSecret(spec).encoded
    return Base64.getEncoder().encodeToString(hash)
}
