package model

import AdminInterface
import hashPassword
import salt
import java.time.LocalDate

class AdminUser(
    userId: Int,
    email: String,
    login: String,
    password: String,
    lastAuthorizeDate: LocalDate,
) : User(userId, email, login, password, lastAuthorizeDate), AdminInterface{
    override fun allUsers(authorizeList: MutableList<User>){
        for (user in authorizeList){
            println(user.login)
        }
    }
    override fun changeUserPassword(authorizeList: MutableList<User>){
        println("email for update")
        val email = readln()
        println("new password")
        val password = readln()

        val user = authorizeList.find { it.email == email }
        require(user != null){
            "no user with that email"
        }

        user.password = hashPassword(password, salt)
    }
    override fun removeUser(authorizeList: MutableList<User>){
        println("email for removing")
        val email = readln()

        val removed = authorizeList.removeIf{it.email == email}
        if (removed){
            println("removed")
        } else{
            println("didn't")
        }
    }
    override fun allUsersSorted(authorizeList: MutableList<User>){
        authorizeList.sortByDescending { it.lastAuthorizeDate }
        for(user in authorizeList){
            println(user.login + " auth at " + user.lastAuthorizeDate)
        }
    }
}
